#include <stdio.h>
#include <math.h>
#include <queue>
#include <map>
#include <vector>

using namespace std;

struct Point {
	int x, y, z;
};

struct Vector {
	int x, y, z;
};

struct Node {
	Point point;
	float length;
	Vector in;

	bool operator<( Node const &a ) {
		return this->length < a.length;
	}
};

float get_distance( Point a, Point b ) {
	return sqrt( ( a.x - b.x ) * ( a.x - b.x ) + ( a.y - b.y ) * ( a.y - b.y ) + ( a.z - b.z ) * ( a.z - b.z ) );
}

float get_angle( Vector in, Vector out ) {
	return 0;
}

Point make_point( int a, int b, int c ) {
	Point p;
	p.x = a;
	p.y = b;
	p.z = c;

	return p;
}

Vector make_vector( Point a, Point b ) {
	Vector v;
	v.x = b.x - a.x;
	v.y = b.y - a.y;
	v.z = b.z - a.z;

	return v;
}

Node make_node( Point p, Vector in, float length ) {
	Node n;
	n.point = p;
	n.length = length;
	n.in = in;
	return n;
}

int main() {
	int n,s,t;
	int x1,x2,x3,y1,y2,y3;	
	map< Node, vector< Node > > neighbours;

	while( scanf( "%d %d %d\n", &n, &s, &t ) == 3 ) {
		scanf( "%d %d %d %d %d %d\n", &x1, &x2, &x3, &y1, &y2, &y3 );
		Point start = make_point( x1, x2, x3 );
		Point finish = make_point( y1, y2, y3 );

		for( int i = 0; i < n; i++ ) {
			scanf( "%d %d %d %d %d %d\n", &x1, &x2, &x3, &y1, &y2, &y3 );
			Point from = make_point( x1, x2, x3 );
			Point to = make_point( y1, y2, y3 );

			neighbours[ from ].push_back( to );
		}

		priority_queue< Node > queue;
		while( !queue.empty() ) {
			Node node = queue.top();
			queue.pop();

			if( node.point == finish ) {
				printf( "%.4f\n", node.length );
				break;
			}

			for( size_t i = 0; i < neighbours[ node.point ].size(); i++ ) {
				Point neighbour = neighbours[ node.point ];
				Vector out = make_vector( node.point, neighbour ); 

				float angle = get_angle( node.in, out );
				float distance = get_distance( node.point, neighbour );
				float length = node.length + distance / s + angle / t;

				queue.push( make_node( neighbour, out, length ) );
			}
		}
	}

	return 0;
}
